
      subroutine airtable(fname,
     &                    kdim,ldim,idim,jdim,
     &                    nAcl,nAtau,nAfun,Acl,Atau,ARe,nA,A,AM)
      character*(*) fname
      real Acl(idim), Atau(jdim), ARe
      integer nA(idim,jdim)
      real A(kdim,ldim,idim,jdim),
     &    AM(kdim,ldim,idim,jdim)

c--------------------------------------------------------------------
      lu = 19
      open(lu,file=fname,status='old')

      read(lu,*) nAcl, nAtau, nAfun, nAmax

      if(nAcl  .gt. idim) stop 'AIRTABLE: Array overflow on idim'
      if(nAtau .gt. jdim) stop 'AIRTABLE: Array overflow on jdim'
      if(nAfun .gt. ldim) stop 'AIRTABLE: Array overflow on ldim'
      if(nAmax .gt. kdim) stop 'AIRTABLE: Array overflow on kdim'

      do i = 1, nAcl
        read(lu,*) Acl(i)
      enddo
      do j = 1, nAtau
        read(lu,*) Atau(j)
      enddo

      read(lu,*) ARe

      do j = 1, nAtau
        do i = 1, nAcl
          read(lu,*) nA(i,j)
          do k = 1, nA(i,j)
            read(lu,*) (A(k,l,i,j), l=1,nAfun)
          enddo
        enddo
      enddo

      close(lu)
c--------------------------------------------------------------------

      do j = 1, nAtau
        do i = 1, nAcl
          do k = 1, nA(i,j)-1
            if(A(k,1,i,j) .ge. A(k+1,1,i,j)) then
             write(*,'(1x,a,a / 1x,a,f10.4,a,f10.4)') 
     &  'In airfoil file  ', fname,
     &  'Mach not monotonically increasing for  CL=', Acl(i),
     &                                      '  tau=', Atau(j)
             stop
            endif
          enddo

          do l=2, nAfun
            call spline(A(1,l,i,j),AM(1,l,i,j),A(1,1,i,j),nA(i,j))
          enddo
        enddo
      enddo

      return

      end
