
      subroutine blsys(simi,lami,wake,direct, Mach, uinv,hksep,
     &                 x,b,rn,th,ds,ue,
     &                 h , h_th, h_ds,
     &                 hk, hk_th, hk_ds, hk_ue,
     &                 hc, hc_th, hc_ds, hc_ue,
     &                 hs, hs_th, hs_ds, hs_ue,
     &                 cf, cf_th, cf_ds, cf_ue,
     &                 di, di_th, di_ds, di_ue,
     &                 xm,bm,rnm,thm,dsm,uem, 
     &                 hm , hm_thm, hm_dsm,
     &                 hkm, hkm_thm, hkm_dsm, hkm_uem,
     &                 hcm, hcm_thm, hcm_dsm, hcm_uem,
     &                 hsm, hsm_thm, hsm_dsm, hsm_uem,
     &                 cfm, cfm_thm, cfm_dsm, cfm_uem,
     &                 dim, dim_thm, dim_dsm, dim_uem,
     &                 aa,bb,rr)
      implicit real (a-h,m,o-z)
      logical simi,lami,wake,direct
      real aa(3,3), bb(3,3), rr(3)

      data pi / 3.1415926535897932384626 /
      data gam / 1.4 /

      gmi = gam - 1.0

      trat = 1.0 + 0.5*gmi*Mach**2 * (1.0-ue**2)
      trat_ue =       -gmi*Mach**2 *      ue

      amsq  = 1.0 + 0.5*gmi*Mach**2 * (1.0-uem**2)
      amsq_uem =       -gmi*Mach**2 *      uem

      rh = trat**(1.0/gmi)
      rh_ue = rh/(gmi*trat) * trat_ue

      rhm = amsq**(1.0/gmi)
      rhm_uem = rhm/(gmi*amsq) * amsq_uem

      if(simi) then
       xl = 1.0
       bl = 1.0
       rl = 0.0
       ul = 1.0
       tl = 0.0
       hl = 0.0
       bl_ds = 0.
       rl_ue = 0.
       ul_ue = 0.
       tl_th = 0.
       hl_hs = 0.
       bl_dsm = 0.
       rl_uem = 0.
       ul_uem = 0.
       tl_thm = 0.
       hl_hsm = 0.

       hl_th = hl_hs*hs_th
       hl_ds = hl_hs*hs_ds
       hl_ue = hl_hs*hs_ue
       hl_thm = 0.
       hl_dsm = 0.
       hl_uem = 0.

       cfxa    = 0.5*cf   *x/th
       cfxa_th = 0.5*cf_th*x/th - cfxa/th
       cfxa_ds = 0.5*cf_ds*x/th
       cfxa_ue = 0.5*cf_ue*x/th
       cfxa_thm = 0.
       cfxa_dsm = 0.
       cfxa_uem = 0.

       dcxa    = di   *x/th - 0.5*cf   *x/th           
       dcxa_th = di_th*x/th - 0.5*cf_th*x/th - dcxa/th
       dcxa_ds = di_ds*x/th - 0.5*cf_ds*x/th
       dcxa_ue = di_ue*x/th - 0.5*cf_ue*x/th
       dcxa_thm = 0.
       dcxa_dsm = 0.
       dcxa_uem = 0.

       ha     = h
       ha_th  = h_th
       ha_ds  = h_ds
       ha_thm = 0.
       ha_dsm = 0.

       hsa     = hs
       hsa_th  = hs_th
       hsa_ds  = hs_ds
       hsa_ue  = hs_ue
       hsa_thm = 0.
       hsa_dsm = 0.
       hsa_uem = 0.

       hca     = hc
       hca_th  = hc_th
       hca_ds  = hc_ds
       hca_ue  = hc_ue
       hca_thm = 0.
       hca_dsm = 0.
       hca_uem = 0.

      else
       bd  = b  + 2.0*pi*ds *rn
       bdm = bm + 2.0*pi*dsm*rnm

       xl = log(x/xm)
       bl = log(bd/bdm)
       rl = log(rh/rhm)
       ul = log(ue/uem)
       tl = log(th/thm)
       hl = log(hs/hsm)
       bl_ds  =  1.0/bd * 2.0*pi*rn
       rl_ue  =  1.0/rh * rh_ue
       ul_ue  =  1.0/ue
       tl_th  =  1.0/th
       hl_hs  =  1.0/hs
       bl_dsm = -1.0/bdm * 2.0*pi*rnm
       rl_uem = -1.0/rhm * rhm_uem
       ul_uem = -1.0/uem
       tl_thm = -1.0/thm
       hl_hsm = -1.0/hsm

       hl_th = hl_hs*hs_th
       hl_ds = hl_hs*hs_ds
       hl_ue = hl_hs*hs_ue
       hl_thm = hl_hsm*hsm_thm
       hl_dsm = hl_hsm*hsm_dsm
       hl_uem = hl_hsm*hsm_uem

       cfx      = 0.5*cf     *x /th
       cfx_th   = 0.5*cf_th  *x /th  - cfx/th
       cfx_ds   = 0.5*cf_ds  *x /th
       cfx_ue   = 0.5*cf_ue  *x /th
       cfxm     = 0.5*cfm    *xm/thm
       cfxm_thm = 0.5*cfm_thm*xm/thm - cfxm/thm
       cfxm_dsm = 0.5*cfm_dsm*xm/thm
       cfxm_uem = 0.5*cfm_uem*xm/thm

       cfxa     = 0.5*(cfx + cfxm)
       cfxa_th  = 0.5* cfx_th
       cfxa_ds  = 0.5* cfx_ds
       cfxa_ue  = 0.5* cfx_ue
       cfxa_thm = 0.5*       cfxm_thm
       cfxa_dsm = 0.5*       cfxm_dsm
       cfxa_uem = 0.5*       cfxm_uem


       dcx      = di     *x /th  - 0.5*cf     *x /th           
       dcx_th   = di_th  *x /th  - 0.5*cf_th  *x /th - dcx/th
       dcx_ds   = di_ds  *x /th  - 0.5*cf_ds  *x /th
       dcx_ue   = di_ue  *x /th  - 0.5*cf_ue  *x /th
       dcxm     = dim    *xm/thm - 0.5*cfm    *xm/thm           
       dcxm_thm = dim_thm*xm/thm - 0.5*cfm_thm*xm/thm - dcxm/thm
       dcxm_dsm = dim_dsm*xm/thm - 0.5*cfm_dsm*xm/thm
       dcxm_uem = dim_uem*xm/thm - 0.5*cfm_uem*xm/thm
 
       dcxa     = 0.5*(dcx + dcxm)
       dcxa_th  = 0.5* dcx_th
       dcxa_ds  = 0.5* dcx_ds
       dcxa_ue  = 0.5* dcx_ue
       dcxa_thm = 0.5*       dcxm_thm
       dcxa_dsm = 0.5*       dcxm_dsm
       dcxa_uem = 0.5*       dcxm_uem

 
       ha     = 0.5*(h + hm)
       ha_th  = 0.5* h_th
       ha_ds  = 0.5* h_ds
       ha_thm = 0.5*     hm_thm
       ha_dsm = 0.5*     hm_dsm

       hsa     = 0.5*(hs + hsm)
       hsa_th  = 0.5* hs_th
       hsa_ds  = 0.5* hs_ds
       hsa_ue  = 0.5* hs_ue
       hsa_thm = 0.5*      hsm_thm
       hsa_dsm = 0.5*      hsm_dsm
       hsa_uem = 0.5*      hsm_uem

       hca     = 0.5*(hc + hcm)
       hca_th  = 0.5* hc_th
       hca_ds  = 0.5* hc_ds
       hca_ue  = 0.5* hc_ue
       hca_thm = 0.5*      hcm_thm
       hca_dsm = 0.5*      hcm_dsm
       hca_uem = 0.5*      hcm_uem

c       hca = 0.
c       hca_th  = 0.
c       hca_ds  = 0.
c       hca_ue  = 0.
c       hca_thm = 0.
c       hca_dsm = 0.
c       hca_uem = 0.

      endif


      rr(1)   = tl     - cfxa    *xl + (ha + 2.0)*ul  +  bl + rl
      aa(1,1) = tl_th  - cfxa_th *xl +  ha_th    *ul
      aa(1,2) =        - cfxa_ds *xl +  ha_ds    *ul  +  bl_ds
      aa(1,3) =        - cfxa_ue *xl + (ha + 2.0)*ul_ue     + rl_ue
      bb(1,1) = tl_thm - cfxa_thm*xl +  ha_thm   *ul
      bb(1,2) =        - cfxa_dsm*xl +  ha_dsm   *ul  +  bl_dsm
      bb(1,3) =        - cfxa_uem*xl + (ha + 2.0)*ul_uem    + rl_uem


      btmp     =  2.0*hca/hsa + 1.0 - ha 
      btmp_hca =  2.0    /hsa
      btmp_hsa = -2.0*hca/hsa**2
      btmp_ha  =                    - 1.0

      btmp_th = btmp_hca*hca_th + btmp_hsa*hsa_th + btmp_ha*ha_th
      btmp_ds = btmp_hca*hca_ds + btmp_hsa*hsa_ds + btmp_ha*ha_ds
      btmp_ue = btmp_hca*hca_ue + btmp_hsa*hsa_ue

      btmp_thm = btmp_hca*hca_thm + btmp_hsa*hsa_thm + btmp_ha*ha_thm
      btmp_dsm = btmp_hca*hca_dsm + btmp_hsa*hsa_dsm + btmp_ha*ha_dsm
      btmp_uem = btmp_hca*hca_uem + btmp_hsa*hsa_uem

      rr(2)   = hl     - dcxa    *xl + btmp    *ul
      aa(2,1) = hl_th  - dcxa_th *xl + btmp_th *ul
      aa(2,2) = hl_ds  - dcxa_ds *xl + btmp_ds *ul
      aa(2,3) = hl_ue  - dcxa_ue *xl + btmp_ue *ul
     &                               + btmp    *ul_ue
      bb(2,1) = hl_thm - dcxa_thm*xl + btmp_thm*ul
      bb(2,2) = hl_dsm - dcxa_dsm*xl + btmp_dsm*ul
      bb(2,3) = hl_uem - dcxa_uem*xl + btmp_uem*ul
     &                               + btmp    *ul_uem

      if(direct) then
       rr(3)   = ue - uinv
       aa(3,1) = 0.
       aa(3,2) = 0.
       aa(3,3) = 1.0
      else
       rr(3)   = hk - hksep
       aa(3,1) = hk_th
       aa(3,2) = hk_ds
       aa(3,3) = hk_ue
      endif
      bb(3,1) = 0.
      bb(3,2) = 0.
      bb(3,3) = 0.

      return
      end ! blsys





      subroutine blvar(simi,lami,wake, Reyn,Mach, fexcr,
     &                 x, th ,ds ,ue , 
     &                 h , h_th, h_ds,
     &                 hk, hk_th, hk_ds, hk_ue,
     &                 hc, hc_th, hc_ds, hc_ue,
     &                 hs, hs_th, hs_ds, hs_ue,
     &                 cf, cf_th, cf_ds, cf_ue,
     &                 di, di_th, di_ds, di_ue )
      implicit real (a-h,m,o-z)
      logical simi,lami,wake

cc    data acon, bcon / 6.70, 0.75 /
      data acon, bcon / 6.0 , 0.72 /
      data gam / 1.4 /

      
      gmi = gam - 1.0

      trat = 1.0 + 0.5*gmi*Mach**2 * (1.0-ue**2)
      trat_ue =       -gmi*Mach**2 *      ue

      msq = (ue*Mach)**2 / trat
      msq_ue = 2.0*ue*Mach**2 - (msq/trat)*trat_ue

      h    =  ds/th
      h_th =  -h/th
      h_ds = 1.0/th

      call hkin( h , msq , hk, hk_h, hk_msq)
      hk_th = hk_h*h_th
      hk_ds = hk_h*h_ds
      hk_ue = hk_msq*msq_ue

      hk = max( hk , 1.005 )

      rh = trat**(1.0/gmi)
      rh_ue = rh/(gmi*trat) * trat_ue

c---- mu ~ T assumed here.  Could be replaced with Sutherland's Law
      mu = trat/Reyn
      mu_ue = trat_ue/Reyn

      rt    = rh*ue*th/mu
      rt_ue = rh   *th/mu + rh_ue*ue*th/mu  - (rt/mu)*mu_ue
      rt_th = rh*ue   /mu

      if(lami) then
       call hsl( hk, rt, msq, hs, hs_hk, hs_rt, hs_msq )
      else
       call hst( hk, rt, msq, hs, hs_hk, hs_rt, hs_msq )
      endif
      hs_th = hs_hk*hk_th + hs_rt*rt_th
      hs_ds = hs_hk*hk_ds
      hs_ue = hs_hk*hk_ue + hs_rt*rt_ue + hs_msq*msq_ue

c      call hct( hk, msq, hc, hc_hk, hc_msq )
c      hc_th = hc_hk*hk_th
c      hc_ds = hc_hk*hk_ds
c      hc_ue = hc_hk*hk_ue + hc_msq*msq_ue

      hc    = 0.5*gmi*msq   *h
      hc_ue = 0.5*gmi*msq_ue*h
      hc_th = 0.5*gmi*msq   *h_th
      hc_ds = 0.5*gmi*msq   *h_ds

      if(wake) then
       cf    = 0.
       cf_th = 0.
       cf_ds = 0.
       cd_ue = 0.
      else
       if(lami) then
        call cfl( hk, rt, msq, cf, cf_hk, cf_rt, cf_msq )
       else
        call cft( hk, rt, msq, cf, cf_hk, cf_rt, cf_msq )
       endif
       cf     = fexcr * cf
       cf_hk  = fexcr * cf_hk
       cf_rt  = fexcr * cf_rt
       cf_msq = fexcr * cf_msq
       cf_th = cf_hk*hk_th + cf_rt*rt_th
       cf_ds = cf_hk*hk_ds
       cf_ue = cf_hk*hk_ue + cf_rt*rt_ue + cf_msq*msq_ue
      endif

      if(lami) then
       call dil( hk, rt, di, di_hk, di_rt )
       di_th = di_hk*hk_th + di_rt*rt_th
       di_ds = di_hk*hk_ds
       di_ue = di_hk*hk_ue + di_rt*rt_ue
      else
       hrat = (hk-1.0)/(acon*hk)
       hrat_hk = 1.0/(acon*hk**2)

       fc = sqrt(1.0 + 0.5*gmi*msq)
       fc_ue = (0.25*gmi/fc)*msq_ue

       uq      = (0.5*cf - hrat**2/fc  ) / (bcon*hk)
       uq_cf   =  0.5                    / (bcon*hk)
       uq_hrat =      -2.0*hrat   /fc    / (bcon*hk)
       uq_fc   =           hrat**2/fc**2 / (bcon*hk)

       uq_hk = uq_hrat*hrat_hk - uq/hk

       uq_th = uq_cf*cf_th + uq_hk*hk_th
       uq_ds = uq_cf*cf_ds + uq_hk*hk_ds
       uq_ue = uq_cf*cf_ue + uq_hk*hk_ue + uq_fc*fc_ue

       di = 0.5*cf - (hk-1.0)*uq
       di_cf = 0.5
       di_hk = -uq
       di_uq = -(hk-1.0)

       di_th = di_cf*cf_th + di_hk*hk_th + di_uq*uq_th
       di_ds = di_cf*cf_ds + di_hk*hk_ds + di_uq*uq_ds
       di_ue = di_cf*cf_ue + di_hk*hk_ue + di_uq*uq_ue
      endif

      if(wake) then
       wfac = 2.0
       di    = wfac*di
       di_th = wfac*di_th
       di_ds = wfac*di_ds
       di_ue = wfac*di_ue
      endif
 
      return
      end ! blvar



 
 
      SUBROUTINE HKIN( H, MSQ, HK, HK_H, HK_MSQ )
      REAL MSQ
C
C---- calculate kinematic shape parameter (assuming air)
C     (from Whitfield )
      HK     =    (H - 0.29*MSQ)/(1.0 + 0.113*MSQ)
      HK_H   =     1.0          /(1.0 + 0.113*MSQ)
      HK_MSQ = (-.29 - 0.113*HK)/(1.0 + 0.113*MSQ)
C
      RETURN
      END
 


      SUBROUTINE DIL( HK, RT, DI, DI_HK, DI_RT )
C
C---- Laminar dissipation function  ( 2 CD/H* )     (from Falkner-Skan)
      IF(HK.LT.4.0) THEN
       DI    = ( 0.00205  *  (4.0-HK)**5.5 + 0.207 ) / RT
       DI_HK = ( -.00205*5.5*(4.0-HK)**4.5         ) / RT
      ELSE
       HKB = HK - 4.0
       DEN = 1.0 + 0.02*HKB**2
       DI    = ( -.0016  *  HKB**2  /DEN   + 0.207             ) / RT
       DI_HK = ( -.0016*2.0*HKB*(1.0/DEN - 0.02*HKB**2/DEN**2) ) / RT
      ENDIF
      DI_RT = -DI/RT
C
      RETURN
      END


      SUBROUTINE DILW( HK, RT, DI, DI_HK, DI_RT )
      REAL MSQ
C
      MSQ = 0.
      CALL HSL( HK, RT, MSQ, HS, HS_HK, HS_RT, HS_MSQ )
C
C---- Laminar wake dissipation function  ( 2 CD/H* )
      RCD    =  1.10 * (1.0 - 1.0/HK)**2  / HK
      RCD_HK = -1.10 * (1.0 - 1.0/HK)*2.0 / HK**3
     &       - RCD/HK
C
      DI    = 2.0*RCD   /(HS*RT)
      DI_HK = 2.0*RCD_HK/(HS*RT) - (DI/HS)*HS_HK
      DI_RT = -DI/RT             - (DI/HS)*HS_RT
C
      RETURN
      END


      SUBROUTINE HSL( HK, RT, MSQ, HS, HS_HK, HS_RT, HS_MSQ )
      REAL MSQ
C
C---- Laminar HS correlation
      IF(HK.LT.4.35) THEN
       TMP = HK - 4.35
       HS    = 0.0111*TMP**2/(HK+1.0)
     &       - 0.0278*TMP**3/(HK+1.0)  + 1.528
     &       - 0.0002*(TMP*HK)**2
       HS_HK = 0.0111*(2.0*TMP    - TMP**2/(HK+1.0))/(HK+1.0)
     &       - 0.0278*(3.0*TMP**2 - TMP**3/(HK+1.0))/(HK+1.0)
     &       - 0.0002*2.0*TMP*HK * (TMP + HK)
      ELSE
       HS    = 0.015*    (HK-4.35)**2/HK + 1.528
       HS_HK = 0.015*2.0*(HK-4.35)   /HK
     &       - 0.015*    (HK-4.35)**2/HK**2
      ENDIF
C
      HS_RT  = 0.
      HS_MSQ = 0.
C
      RETURN
      END


      SUBROUTINE CFL( HK, RT, MSQ, CF, CF_HK, CF_RT, CF_MSQ )
      REAL MSQ
C
C---- Laminar skin friction function  ( Cf )    ( from Falkner-Skan )
      IF(HK.LT.5.5) THEN
       TMP = (5.5-HK)**3 / (HK+1.0)
       CF    = ( 0.0727*TMP                      - 0.07       )/RT
       CF_HK = ( -.0727*TMP*3.0/(5.5-HK) - 0.0727*TMP/(HK+1.0))/RT
      ELSE
       TMP = 1.0 - 1.0/(HK-4.5)
       CF    = ( 0.015*TMP**2      - 0.07  ) / RT
       CF_HK = ( 0.015*TMP*2.0/(HK-4.5)**2 ) / RT
      ENDIF
      CF_RT = -CF/RT
      CF_MSQ = 0.0
C
      RETURN
      END



      SUBROUTINE DIT( HS, US, CF, ST, DI, DI_HS, DI_US, DI_CF, DI_ST )
C
C---- Turbulent dissipation function  ( 2 CD/H* )
      DI    =  ( 0.5*CF*US + ST*ST*(1.0-US) ) * 2.0/HS
      DI_HS = -( 0.5*CF*US + ST*ST*(1.0-US) ) * 2.0/HS**2
      DI_US =  ( 0.5*CF    - ST*ST          ) * 2.0/HS
      DI_CF =  ( 0.5   *US                  ) * 2.0/HS
      DI_ST =  (            2.0*ST*(1.0-US) ) * 2.0/HS
C
      RETURN
      END


      SUBROUTINE HST( HK, RT, MSQ, HS, HS_HK, HS_RT, HS_MSQ )
      IMPLICIT REAL (A-H,M,O-Z)
C
C---- Turbulent HS correlation
C
      DATA HSMIN, DHSINF / 1.500, 0.015 /
C
C---- ###  12/4/94
C---- limited Rtheta dependence for Rtheta < 200
C
C
      IF(RT.GT.400.0) THEN
       HO    = 3.0 + 400.0/RT
       HO_RT =     - 400.0/RT**2
      ELSE
       HO    = 4.0
       HO_RT = 0.
      ENDIF
C
      IF(RT.GT.200.0) THEN
       RTZ    = RT
       RTZ_RT = 1.
      ELSE
       RTZ    = 200.0
       RTZ_RT = 0.
      ENDIF
C
      IF(HK.LT.HO) THEN
C----- attached branch
C=======================================================
C----- old correlation
C-     (from Swafford profiles)
c       SRT = SQRT(RT)
c       HEX = (HO-HK)**1.6
c       RTMP = 0.165 - 1.6/SRT
c       HS    = HSMIN + 4.0/RT + RTMP*HEX/HK
c       HS_HK = RTMP*HEX/HK*(-1.6/(HO-HK) - 1.0/HK)
c       HS_RT = -4.0/RT**2 + HEX/HK*0.8/SRT/RT
c     &             + RTMP*HEX/HK*1.6/(HO-HK)*HO_RT
C=======================================================
C----- new correlation  29 Nov 91
C-     (from  arctan(y+) + Schlichting  profiles)
       HR    = ( HO - HK)/(HO-1.0)
       HR_HK =      - 1.0/(HO-1.0)
       HR_RT = (1.0 - HR)/(HO-1.0) * HO_RT
       HS    = (2.0-HSMIN-4.0/RTZ)*HR**2  * 1.5/(HK+0.5) + HSMIN
     &       + 4.0/RTZ
       HS_HK =-(2.0-HSMIN-4.0/RTZ)*HR**2  * 1.5/(HK+0.5)**2
     &       + (2.0-HSMIN-4.0/RTZ)*HR*2.0 * 1.5/(HK+0.5) * HR_HK
       HS_RT = (2.0-HSMIN-4.0/RTZ)*HR*2.0 * 1.5/(HK+0.5) * HR_RT
     &       + (HR**2 * 1.5/(HK+0.5) - 1.0)*4.0/RTZ**2 * RTZ_RT
C
      ELSE
C
C----- separated branch
       GRT = LOG(RTZ)
       HDIF = HK - HO 
       RTMP = HK - HO + 4.0/GRT
       HTMP    = 0.007*GRT/RTMP**2 + DHSINF/HK
       HTMP_HK = -.014*GRT/RTMP**3 - DHSINF/HK**2
       HTMP_RT = -.014*GRT/RTMP**3 * (-HO_RT - 4.0/GRT**2/RTZ * RTZ_RT)
     &         + 0.007    /RTMP**2 / RTZ * RTZ_RT
       HS    = HDIF**2 * HTMP + HSMIN + 4.0/RTZ
       HS_HK = HDIF*2.0* HTMP
     &       + HDIF**2 * HTMP_HK
       HS_RT = HDIF**2 * HTMP_RT      - 4.0/RTZ**2 * RTZ_RT
     &       + HDIF*2.0* HTMP * (-HO_RT)
C
      ENDIF
C
C---- fudge HS slightly to make sure   HS -> 2   as   HK -> 1
C-    (unnecessary with new correlation)
c      HTF    = 0.485/9.0 * (HK-4.0)**2/HK  +  1.515
c      HTF_HK = 0.485/9.0 * (1.0-16.0/HK**2)
c      ARG = MAX( 10.0*(1.0 - HK) , -15.0 )
c      HXX = EXP(ARG)
c      HXX_HK = -10.0*HXX
cC
c      HS_HK  = (1.0-HXX)*HS_HK  +  HXX*HTF_HK
c     &       + (        -HS     +      HTF    )*HXX_HK
c      HS_RT  = (1.0-HXX)*HS_RT
c      HS     = (1.0-HXX)*HS     +  HXX*HTF
C
C---- Whitfield's minor additional compressibility correction
      FM = 1.0 + 0.014*MSQ
      HS     = ( HS + 0.028*MSQ ) / FM
      HS_HK  = ( HS_HK          ) / FM
      HS_RT  = ( HS_RT          ) / FM
      HS_MSQ = 0.028/FM  -  0.014*HS/FM
C
      RETURN
      END
 
 
 
      SUBROUTINE CFT( HK, RT, MSQ, CF, CF_HK, CF_RT, CF_MSQ )
      IMPLICIT REAL (A-H,M,O-Z)
C
      DATA GAM /1.4/

      CFFAC = 1.0
C
C---- Turbulent skin friction function  ( Cf )    (Coles)
      GMI = GAM - 1.0
      FC = SQRT(1.0 + 0.5*GMI*MSQ)
      GRT = LOG(RT/FC)
      GRT = MAX(GRT,3.0)
C
      GEX = -1.74 - 0.31*HK
C
      ARG = -1.33*HK
      ARG = MAX(-20.0, ARG )
C
      THK = TANH(4.0 - HK/0.875)
C
      CFO =  CFFAC * 0.3*EXP(ARG) * (GRT/2.3026)**GEX
      CF     = ( CFO  +  1.1E-4*(THK-1.0) ) / FC
      CF_HK  = (-1.33*CFO - 0.31*LOG(GRT/2.3026)*CFO
     &         - 1.1E-4*(1.0-THK**2) / 0.875    ) / FC
      CF_RT  = GEX*CFO/(FC*GRT) / RT
      CF_MSQ = GEX*CFO/(FC*GRT) * (-0.25*GMI/FC**2) - 0.25*GMI*CF/FC**2
C
      RETURN
      END ! CFT



 
      SUBROUTINE HCT( HK, MSQ, HC, HC_HK, HC_MSQ )
      REAL MSQ
C
C---- density shape parameter    (from Whitfield)
      HC     = MSQ * (0.064/(HK-0.8) + 0.251)
      HC_HK  = MSQ * (-.064/(HK-0.8)**2     )
      HC_MSQ =        0.064/(HK-0.8) + 0.251
C
      RETURN
      END
