
      integer nc, nbl, iblte
      common /fbl_i/
     &  nc,     ! number of control points for fuselage potential-flow problem
     &  nbl,    ! number of BL+wake points
     &  iblte   ! index of TE point

      integer nbldim
      parameter (nbldim=60)
      common  /fbl_r/
     &  xbl(nbldim),      ! body x coordinates
     &  zbl(nbldim),      ! body z coordinates
     &  sbl(nbldim),      ! body + wake arc length  (BL coordinate)
     &  dybl(nbldim),     ! body y-offset of edge-type tail
     &  bbl(nbldim),      ! transverse width (body perimeter)
     &  rnbl(nbldim),     ! dr/dn  (cosine of body contour angle from axis)
     &  uinv(nbldim),     ! inviscid edge velocity (in absence of delta*)
     &  uebl(nbldim),     ! actual edge velocity
     &  dsbl(nbldim),     ! displacement thickness delta*
     &  thbl(nbldim),     ! momentum thickness theta
     &  tsbl(nbldim),     ! K.E. thickness  theta*
     &  dcbl(nbldim),     ! density flux thickness  delta**
     &  ctbl(nbldim),     ! max shear stress coefficient
     &  cqbl(nbldim),     ! equilib.max shear stress coefficient
     &  cfbl(nbldim),     ! skin friction coefficient
     &  cdbl(nbldim),     ! dissipation coefficient
     &  hkbl(nbldim),     ! kinematic shape parameter
     &  phbl(nbldim)      ! running integral of dissipation
