      subroutine hsort(n,a,indx)
      dimension a(n)
      dimension indx(n)
c--------------------------------------
c     heapsort algorithm.
c     returns indx(.) such that
c
c       a(indx(i)) < a(indx(i+1))
c
c     stolen from numerical recipes.
c--------------------------------------
c
      do i = 1, n
        indx(i) = i
      enddo
c
      if(n.le.1) return
c
      l = n/2 + 1
      ir = n
c
 10   continue
      if(l.gt.1) then
        l = l-1
        indxt = indx(l)
        q = a(indxt)
      else
        indxt = indx(ir)
        q = a(indxt)
        indx(ir) = indx(1)
c
        ir = ir - 1
        if(ir.eq.1) then
          indx(1) = indxt
          return
        endif
      endif
c
      i = l
      j = l+l
c
 20   if(j.le.ir) then
        if(j.lt.ir) then
          if(a(indx(j)) .lt. a(indx(j+1))) j = j+1
        endif
        if(q .lt. a(indx(j))) then
          indx(i) = indx(j)
c
          i = j
          j = j+j
        else
          j = ir+1
        endif
        go to 20
      endif
c
      indx(i) = indxt
      go to 10
      end


