
      implicit real (a-z)

      integer type, method

      data pi / 3.1415926535897932384626 /

      A6 = 0.08
      A8 = 0.35
      u6 = 711
      u8 = 300
      T6 = 876
      T8 = 300
      M0=0.2
      etaf=0.85
      FPR=1.64
      mdot=21.85
      BPR=5.7


      h = 300.0

      rhoa = 1.1430
      Pa = 9.7775e+04
      Ta = 298.1188
      visca = 1.8373e-05
      ca = 346.0985


c% Mt is the tip Mach number.
c% Mrt is the relative flow Mach number at the tip.
c% Mrtd is the relative flow Mach number at the tip at design conditions
c% RPM is the fan rotational speed
      Mt=1.2
      Mtr=1.38
      Mtrd=1.30
      RPM=5400
      neng=4
      type = 0

      method = 2

      rss  = 302   ! Rotor Stator Spacing
      B    = 20    ! Number rotor blades
      V    = 44    ! Number stator blades
      htr  = 0.29  ! Hub tip ratio


      x = 0.0
      y = 450.0
      z = 0.0

c     x = 100.0

      climb  =  5.0 * pi/180.0
      alpha  =  5.0 * pi/180.0
      vector = 10.0 * pi/180.0

      call tfnoise(
     &       x,y,z,
     &       climb,alpha,vector, 
     &       rhoa, Pa, Ta, visca, ca,
     &       A6,A8,u6,u8,T6,T8,M0,
     &       etaf,FPR,mdot,
     &       BPR,Mtrd,Mtr,Mt,RPM,
     &       rss,B,V,htr,
     &       neng,type,method,
     &       spl_jet_dba,
     &       spl_f_t_dba,
     &       spl_f_b_dba,
     &       spl_f_z_dba,
     &       spl_r_t_dba,
     &       spl_r_b_dba,
     &       spl_tot_dba )


      write(*,*) 'Jet                    = ', spl_jet_dba
      write(*,*) 'Foward Fan Tonal       = ', spl_f_t_dba
      write(*,*) 'Foward Fan Broadband   = ', spl_f_b_dba
      write(*,*) 'Foward Fan Buzzsaw     = ', spl_f_z_dba
      write(*,*) 'Rearward Fan Tonal     = ', spl_r_t_dba
      write(*,*) 'Rearward Fan Broadband = ', spl_r_b_dba
      write(*,*) 'Total                  = ', spl_tot_dba

      stop
      end
