
      program tftest
c--------------------------------------------------------------------
c     Exercises tfsize and tfopr routines.
c
c     NOT UP TO DATE!
c--------------------------------------------------------------------
      implicit real (a-z)
      integer ifuel, i, ii
      integer icool, ipass, iTFspec, iBLIc
      integer ncrowx, ncrow, icrow
      logical Lconv

      data pi / 3.1415926535897932384626 /

      parameter (ncrowx=10)
      real Tmrow(ncrowx),
     &     epsrow(ncrowx),
     &     epsrow_Tt3(ncrowx),
     &     epsrow_Tt4(ncrowx),
     &     epsrow_Trr(ncrowx)

      gee = 9.81
      TSL = 288.0
      pSL = 1.013e5

      Tref = TSL
      pref = pSL

c---- freestream gas properties
      cp = 1004.0
      gam = 1.4

c---- average compressor gas properties,
c-     for estimating Tt3 for cooling flow calculation
      cpc = 1025.0
      Rgc = 288.0

c---- turbine inlet gas properties
c-     for estimating turbine blade row temperature drops
      cp4 = 1340.0
      Rg4 = 288.0

c---- axial Mach numbers
      M2  = 0.6     ! fan
      M25 = 0.6     ! compressor

c---- tangential tip Mach numbers 
      Mfrot = 1.4   ! fan
      Mcrot = 1.3   ! HP compressor

c---- engine design parameters
      BPR = 10.75
      OPR = 30.0
      pif = 1.5
      pihc = 12.0
      pid = 0.97
      pib = 0.99
      pifn = 0.99
      pitn = 0.99

      pic1 = 1.4
      epolf  = 0.90
      epollc = 0.90
      epolhc = 0.90
      epolht = 0.90
      epollt = 0.90

      etab = 0.98

      Gearf = 1.0
      HTRf  = 0.35
      HTRlc = 0.70
      HTRhc = 0.80

      pilc = OPR/pihc
      nstagelc = log(pilc/pif)/log(pic1)
      nstagehc = log(pihc    )/log(pic1)

c---- 0 km (takeoff)
      altkm = 0.0
      M0to = 0.25
      call atmos(altkm, T0to,p0to,rho0to,a0to,mu0to)

c---- 31 kft (cruise)
      altkm = 31.0 / 3.28
      M0 = 0.72
      call atmos(altkm, T0,p0,rho0,a0,mu0)

      Feng = 8687.3359

      Tfuel = 280.0
      ifuel = 24



c---- Tmetal
c     2000F = 1366K
c     2100F = 1423K
      Tmetal = 1350.0
c     Tmetal = 2400.0  !###

c---- T4
c     2700F = 1755.0
c     2900F = 1866.0
c     3100F = 1977.0
      Tt4to = 1920.0
      Tt4cl1 = 1600.0
      Tt4cl2 = 1600.0
      Tt4cr  = 1400.0
      Tt4de1 = 1050.0
      Tt4de2 = 1275.0

c---- cooling model constants
      dTstrk = 200.0
      StA = 0.06
      efilm = 0.7
      tfilm = 0.4
      Mtexit = 1.0
      M4a = 1.0
      ruc = 0.3

c---- calculate cooling mass flow ratios epsrow(.) to get specified Tmrow(.)
      OPR = pilc*pihc
      OPRto = OPR * 1.4
      do icrow = 1, ncrowx
        Tmrow(icrow) = Tmetal
      enddo
      Tt2to = T0to*(1.0 + 0.5*(gam-1.0) * M0to**2)
      Tt3to = Tt2to * OPRto**(Rgc/(epolhc*cpc))
      Trrat = 1.0 / (1.0 + 0.5*Rg4/(cp4-Rg4) * Mtexit**2)
      call mcool(ncrowx, ncrow,
     &           Tmrow,Tt3to,Tt4to,dTstrk, Trrat,
     &           efilm,tfilm,StA, 
     &           epsrow,epsrow_Tt3,epsrow_Tt4,epsrow_Trr)


c      do icrow = 1, ncrow
c        write(*,'(1x,i3,a,2f8.5)') 
c     &      icrow, ' theta  eps =', throw(icrow), epsrow(icrow)
c      enddo
c      write(*,*)


c      ii = 401
c      do i = 2, ii
c        frac = float(i-1) / float(ii-1)
c        pif = 1.0 + 0.65*frac


      pif = 1.5
      pifK = 1.4
      epfK = -0.05

      Tt4 = Tt4cr

      write(*,*)
      write(*,*) 'TFSIZE  M0 p0 =', M0, p0
      write(*,*) '        Tt4 F =', Tt4, Feng
      write(*,*) '        altkm =', altkm

      icool = 1

      Phiinl = 500000.0

      iBLIc = 1

      call tfsize(gee,M0,T0,p0,a0, M2,M25,
     &            Feng, Phiinl,iBLIc,
     &            BPR,pif,pilc,pihc,
     &            pid,pib,pifn,pitn,
     &            Tfuel,ifuel,etab,
     &            epolf,epollc,epolhc,epolht,epollt,
     &            pifK,epfK,
     &            icool,
     &            Mtexit,dTstrk,StA,efilm,tfilm,
     &            M4a,ruc,
     &            ncrowx,ncrow,
     &            epsrow,Tmrow,                   ! input or output
     &            TSFC,Fsp,hfuel,ff,mdot,         ! outputs
     &            Tt0 ,ht0 ,pt0 ,cpt0 ,Rt0 ,      !
     &            Tt18,ht18,pt18,cpt18,Rt18,
     &            Tt19,ht19,pt19,cpt19,Rt19,
     &            Tt2 ,ht2 ,pt2 ,cpt2 ,Rt2 ,
     &            Tt21,ht21,pt21,cpt21,Rt21,
     &            Tt25,ht25,pt25,cpt25,Rt25,
     &            Tt3 ,ht3 ,pt3 ,cpt3 ,Rt3 ,
     &            Tt4, ht4 ,pt4 ,cpt4 ,Rt4 ,
     &            Tt41,ht41,pt41,cpt41,Rt41,
     &            Tt45,ht45,pt45,cpt45,Rt45,
     &            Tt49,ht49,pt49,cpt49,Rt49,
     &            Tt5 ,ht5 ,pt5 ,cpt5 ,Rt5 ,
     &            Tt7 ,ht7 ,pt7 ,cpt7 ,Rt7 ,
     &                 u0 ,
     &             T2, u2 ,p2 ,cp2 ,R2 ,A2 ,
     &             T25,u25,p25,cp25,R25,A25,
     &             T5 ,u5 ,p5 ,cp5 ,R5 ,A5 ,
     &             T6 ,u6 ,p6 ,cp6 ,R6 ,A6 ,
     &             T7 ,u7 ,p7 ,cp7 ,R7 ,A7 ,
     &             T8 ,u8 ,p8 ,cp8 ,R8 ,A8 ,
     &            epf ,eplc ,ephc ,epht ,eplt , 
     &            etaf,etalc,etahc,etaht,etalt,
     &            Lconv )

      epstot = 0.
      do icrow = 1, ncrow
        epstot = epstot + epsrow(icrow)
      enddo

c---- design speeds
      Nf = 1.0/Gearf
      N1 = 1.0
      N2 = 1.0

c---- corrected values
      Nbf  = Nf/sqrt(Tt2 /Tref)
      Nblc = N1/sqrt(Tt19/Tref)
      Nbhc = N2/sqrt(Tt25/Tref)
      Nbht = N2/sqrt(Tt41/Tref)
      Nblt = N1/sqrt(Tt45/Tref)
      mbf  = mdot*sqrt(Tt2 /Tref)/(pt2 /pref)*BPR
      mblc = mdot*sqrt(Tt19/Tref)/(pt19/pref)
      mbhc = mdot*sqrt(Tt25/Tref)/(pt25/pref)
      mbht = mdot*sqrt(Tt41/Tref)/(pt41/pref)*(1.0+ff)
      mblt = mdot*sqrt(Tt45/Tref)/(pt45/pref)*(1.0+ff)

c---- design corrected values
      NbfD  = Nbf
      NblcD = Nblc
      NbhcD = Nbhc
      NbhtD = Nbht
      NbltD = Nblt

      mbfD  = mbf
      mblcD = mblc
      mbhcD = mbhc
      mbhtD = mbht
      mbltD = mblt

      pifD  = pif
      pilcD = pilc
      pihcD = pihc

c      pihtD = pt41/pt45
c      piltD = pt45/pt49


      Trh =  Tt41/(Tt41 + (ht45-ht41)/cpt41)
      gexh = cpt41/(Rt41*epolht)
      pihtD = Trh**gexh

      Trl =  Tt45/(Tt45 + (ht49-ht45)/cpt45)
      gexl = cpt45/(Rt45*epollt)
      piltD = Trl**gexl


c      write(*,'(1x,3f11.5)') pifD , mfbD , NfbD
c      write(*,'(1x,3f11.5)') pilcD, mlcbD, NlcbD
c      write(*,'(1x,3f11.5)') pihcD, mhcbD, NhcbD

      Alc = A2/(1.0+BPR)
      Rf  = sqrt(A2 /(pi*(1.0-HTRf**2)))
      Rlc = sqrt(Alc/(pi*(1.0-HTRlc**2)))
      Rhc = sqrt(A25/(pi*(1.0-HTRhc**2)))

      omegaf  = Mfrot*(u2 /M2 ) / Rf
      omegahc = Mcrot*(u25/M25) / Rhc
      omegalc = omegaf*Gearf

      M19 = M2
      T2  = Tt2 /(1.0 + 0.5*(gam-1.0)*M2**2 )
      p2  = pt2 /(1.0 + 0.5*(gam-1.0)*M2**2 )**(gam/(gam-1.0))
      T19 = Tt19/(1.0 + 0.5*(gam-1.0)*M19**2)
      p19 = pt19/(1.0 + 0.5*(gam-1.0)*M19**2)**(gam/(gam-1.0))
      T25 = Tt25/(1.0 + 0.5*(gam-1.0)*M25**2)
      p25 = pt25/(1.0 + 0.5*(gam-1.0)*M25**2)**(gam/(gam-1.0))

      rho2  = p2 /(Rt2 *T2 )
      rho19 = p19/(Rt19*T19)
      rho25 = p25/(Rt25*T25)

      comegaf  = omegaf  / sqrt(T2 /TSL)
      comegalc = omegalc / sqrt(T19/TSL)
      comegahc = omegahc / sqrt(T25/TSL)

      gamexf = (gam-1.0)/(gam*epolf)
      gamexc = (gam-1.0)/(gam*epollc)

      psif  = (pif -1.0)*pt2 /(rho2 *(omegaf *Rf )**2)
      psilc = (pic1-1.0)*pt19/(rho19*(omegalc*Rlc)**2)
      psihc = (pic1-1.0)*pt25/(rho25*(omegahc*Rhc)**2)


      dfan   = 2.0*Rf
      dlcomp = 2.0*Rlc
      dhcomp = 2.0*Rhc

c       write(*,'(1x,8g14.6)') pif, TSFC*3600.0, u6/u0, u8/u0
c      if(u6 .gt. 0.0) then
c       write(1,'(1x,8g14.6)') pif, TSFC*3600.0, u6/u0, u8/u0
c      endif
c      enddo


 3000 format(1x,a,9g13.5)

 3100  format(
     & /'   i     Tt      pt       cpt       Rt    cpt/(cpt-Rt)',
     & /'         K       kPa     J/kg K   J/kg K')
c         10    1500.0   400.12   1020.0    287.0   1.4234
c         123 23456789 23456789 23456789 23456789 23456789
 3150  format(1x,a, f9.1, f9.2, f9.1, f9.1, f9.4)
c
 3210 format(
     & /'    i      dh/dT     eta')
 3250 format(1x,a, f9.1, f9.4)
c           4.5-5.5   1210.0   0.8612
c          12345678 23456789 23456789

 3300  format(
     & /'   i    T       p       M       u        A     Fsp    eta_p',
     & /'        K      kPa             m/s      m^2')
c         10   1500.0  400.12  0.9042  602.00  0.4123  0.4123  0.7801
c         123 2345678 2345678 2345678 2345678 2345678 2345678 23456789
 3350  format(1x,i3, f8.1, f8.2, f8.4, f8.2, f8.4, f8.4, f8.4)

       write(*,*)
       write(*,3000) 'BPR    =', BPR
       write(*,3000) 'FPR    =', pif
       write(*,3000) 'OPR    =', pilc*pihc
       write(*,3000) 'pilc   =', pilc
       write(*,3000) 'pihc   =', pihc
       write(*,3000) '1/piht =', pt41/pt45
       write(*,3000) '1/pilt =', pt45/pt49
       write(*,3000) 'pid    =', pid
       write(*,3000) 'pib    =', pib
       write(*,3000) 'N1     =', N1  
       write(*,3000) 'N2     =', N2  
       write(*,3000) 'Nlc_c% =', Nblc/NblcD * 100.0
       write(*,3000) 'Nhc_c% =', Nbhc/NbhcD * 100.0
       write(*,3000) 'Nht_c% =', Nbht/NbhtD * 100.0
       write(*,3000) 'Nlt_c% =', Nblt/NbltD * 100.0
       write(*,3000) 'mlc_c% =', mblc/mblcD * 100.0
       write(*,3000) 'mhc_c% =', mbhc/mbhcD * 100.0
       write(*,3000) 'mht_c% =', mbht/mbhtD * 100.0
       write(*,3000) 'mlt_c% =', mblt/mbltD * 100.0
       write(*,3000) 'mf_c%  =', mbf /mbfD  * 100.0
       write(*,3000) 'epf    =', epf
       write(*,3000) 'eplc   =', eplc
       write(*,3000) 'ephc   =', ephc
       write(*,3000) 'epht   =', epht
       write(*,3000) 'eplt   =', eplt
       write(*,*)
       write(*,3000) 'hfuel  =', hfuel
       write(*,3000) 'epstot =', epstot
       write(*,3000) 'epsrow =', (epsrow(icrow), icrow=1,ncrow)
       write(*,3000) 'Tmrow  =', (Tmrow(icrow) , icrow=1,ncrow)
ccc    write(*,3000) 'M4a    =', M4a
       write(*,*)
       write(*,3000) 'Tfuel =', Tfuel
       write(*,3000) 'ffuel =', ff
       write(*,3000) 'eta_f =', etaf
       write(*,3000) 'eta_lc=', etalc
       write(*,3000) 'eta_hc=', etahc
       write(*,3000) 'eta_ht=', etaht
       write(*,3000) 'eta_lt=', etalt
       write(*,3000) 'TSFC  =', TSFC, TSFC*3600.0
       write(*,3000) 'Fsp   =', Fsp

       write(*,3000) 'Feng  =', Feng
       write(*,3000) 'mcore =', mdot
       write(*,3000) 'Df    =', dfan  *39.37
       write(*,3000) 'Dlc   =', dlcomp*39.37
       write(*,3000) 'Dhc   =', dhcomp*39.37

c       write(*,3000) 'CRPMf =', comegaf  * 30.0/pi
c       write(*,3000) 'CRPMlc=', comegalc * 30.0/pi
c       write(*,3000) 'CRPMhc=', comegahc * 30.0/pi
c       write(*,3000) 'psif  =', psif
c       write(*,3000) 'psilc =', psilc
c       write(*,3000) 'psihc =', psihc
c       write(*,3000) 'pic1  =', pic1
c       write(*,3000) 'NstgLC=', nstagelc
c       write(*,3000) 'NstgHC=', nstagehc


       write(*,3100)
       write(*,3150)' 0 ',Tt0 ,pt0 /1000.0,cpt0 ,Rt0 ,cpt0 /(cpt0 -Rt0 )
       write(*,3150)' 18',Tt18,pt18/1000.0,cpt18,Rt18,cpt18/(cpt18-Rt18)
       write(*,3150)' 19',Tt19,pt19/1000.0,cpt19,Rt19,cpt19/(cpt19-Rt19)
       write(*,3150)' 2 ',Tt2 ,pt2 /1000.0,cpt2 ,Rt2 ,cpt2 /(cpt2 -Rt2 )
       write(*,3150)' 21',Tt21,pt21/1000.0,cpt21,Rt21,cpt21/(cpt21-Rt21)
       write(*,3150)' 25',Tt25,pt25/1000.0,cpt25,Rt25,cpt25/(cpt25-Rt25)
       write(*,3150)' 3 ',Tt3 ,pt3 /1000.0,cpt3 ,Rt3 ,cpt3 /(cpt3 -Rt3 )
       write(*,3150)' 4 ',Tt4 ,pt4 /1000.0,cpt4 ,Rt4 ,cpt4 /(cpt4 -Rt4 )
       write(*,3150)' 41',Tt41,pt41/1000.0,cpt41,Rt41,cpt41/(cpt41-Rt41)
       write(*,3150)' 45',Tt45,pt45/1000.0,cpt45,Rt45,cpt45/(cpt45-Rt45)
       write(*,3150)' 49',Tt49,pt49/1000.0,cpt49,Rt49,cpt49/(cpt49-Rt49)
       write(*,3150)' 5 ',Tt5 ,pt5 /1000.0,cpt5 ,Rt5 ,cpt5 /(cpt5 -Rt5 )
       write(*,3150)' 7 ',Tt7 ,pt7 /1000.0,cpt7 ,Rt7 ,cpt7 /(cpt7 -Rt7 )

       write(*,3210)
       write(*,3250) ' 2 -21', (ht21-ht2 )/(Tt21-Tt2 ), etaf
       write(*,3250) ' 19-25', (ht25-ht19)/(Tt25-Tt19), etalc
       write(*,3250) ' 25-3 ', (ht3 -ht25)/(Tt3 -Tt25), etahc
       write(*,3250) ' 41-45', (ht45-ht41)/(Tt45-Tt41), etaht
       write(*,3250) ' 45-49', (ht49-ht45)/(Tt49-Tt45), etalt
c
       M5 = u5 / sqrt(T5*R5*cp5/(cp5-R5))
       M6 = u6 / sqrt(T6*R6*cp6/(cp6-R6))
       M7 = u7 / sqrt(T7*R7*cp7/(cp7-R7))
       M8 = u8 / sqrt(T8*R8*cp8/(cp8-R8))
       ep6 = 2.0/(1.0 + u6/u0)
       ep8 = 2.0/(1.0 + u8/u0)
       F6sp =     ((1.0+ff)*u6 - u0)/((1.0+BPR)*a0)
       F8sp = BPR*(         u8 - u0)/((1.0+BPR)*a0)
       Fsp = F6sp + F8sp
       Acap = mdot*(1.0+BPR)/(rho0*u0)
       write(*,3300)
       write(*,3350) 0, T0, p0/1000.0, M0, u0, Acap, Fsp  
       write(*,3350) 2, T2, p2/1000.0, M2, u2, A2
       write(*,*)
       write(*,3350) 25,T25,p25/1000.0,M25,u25,A25
       write(*,*)
       write(*,3350) 5, T5, p5/1000.0, M5, u5, A5  
       write(*,3350) 6, T6, p6/1000.0, M6, u6, A6  , F6sp, ep6
       write(*,*)
       write(*,3350) 7, T7, p7/1000.0, M7, u7, A7
       write(*,3350) 8, T8, p8/1000.0, M8, u8, A8  , F8sp, ep8

c       write(*,*) 'mdot BPR', mdot, BPR
c       write(*,*) 'Tt2  pt2', Tt2, pt2

       write(*,*)
       write(*,'(8a)')
     & '#    mbfD     NbfD     pifD    epf   ',
     &  '    mblD     NblD     pilcD   eplc  ',
     &  '    mbhD     NbhD     pihcD   ephc  ',
     &  '    F8sp     F6sp     Fsp   F(klb)   TSFC'
c        12345678 12345678 12345678 12345678 12345678 12345678 12345678 12345678 
       write(*,'(1x,20f9.5)') 
     &  mbfD , NblcD, pifD , epf , 
     &  mblcD, NblcD, pilcD, eplc, 
     &  mbhcD, NbhcD, pihcD, ephc,
     &  F8sp, F6sp, Fsp, Feng/4450.0, TSFC*3600.0


       write(*,*)
       write(*,'(8a)')
     & '#    mfc/D    Nfc/D    pif     epf   ',
     &  '    mlc/D    Nlc/D    pilc    eplc  ',
     &  '    mhc/D    Nhc/D    pihc    ephc  ',
     &  '    F8sp     F6sp     Fsp   F(klb)   TSFC'
c        12345678 12345678 12345678 12345678 12345678 12345678 12345678 12345678 
       write(*,'(1x,20f9.5)') 
     &  mbf /mbfD , Nblc/NblcD, pif , epf , 
     &  mblc/mblcD, Nblc/NblcD, pilc, eplc, 
     &  mbhc/mbhcD, Nbhc/NbhcD, pihc, ephc,
     &  F8sp, F6sp, Fsp, Feng/4450.0, TSFC*3600.0

       pause

c       altkm = 0.
c       M0 = 0.25

c      altkm = 31.0 / 3.28
c      M0 = 0.72

c      altkm = 37.0 / 3.28
c      M0 = 0.72


c       Tt4 = Tt4to
c       Tt4 = Tt4cl1

c       Tt4 = Tt4cl2
c       Tt4 = Tt4cr
c       Tt4 = Tt4de1

c        Tt4 = Tt4de2

c        Tt4 = 1050.0
c        Tt4 = 1100.0

c        altkm = 0.
c        M0 = 0.185144245604082
c        call atmos(altkm, T0,p0,rho0,a0,mu0)
c        Tt4 = 2001.0
c        icool = 2
c        icool = 1

c       Tt4 = 1400.0

cc      Feng = 1.5*Feng
c      icool = 2

c         pif  = 0.
c         pilc = 0.
c         pihc = 0.

c         mbf  = 0.
c         mblc = 0.
c         mbhc = 0.


c         icool = 0

       do 800 ipass = 1, 2
cc       do 800 ipass = 1, 1


c       if(ipass.eq.1) Tt4 = 1500.0
c       if(ipass.eq.2) Tt4 = 1490.0
c       if(ipass.eq.3) Tt4 = 1485.0
c       if(ipass.eq.4) Tt4 = 1483.0
c       if(ipass.eq.5) Tt4 = 1482.0
c       if(ipass.eq.6) Tt4 = 1481.0
c       if(ipass.eq.7) Tt4 = 1480.0 
c       if(ipass.eq.8) Tt4 = 1479.0


       if(icool.eq.2) then
c------ set specified metal temperature for each blade row
        do icrow = 1, ncrowx
          Tmrow(icrow) = Tmetal
        enddo
       endif
       

      write(*,*)
      write(*,*) 'TFOPER  M0 p0 =', M0, p0
      write(*,*) '        Tt4   =', Tt4
      write(*,*) '        altkm =', altkm

c      iTFspec = 1
      iTFspec = 2


      if(ipass.eq.2) then
c        Feng = Feng*0.30
        Feng = Feng*1.5
        pif = 1.5
        iTFspec = -2
      endif


       call tfoper(gee,M0,T0,p0,a0, Tref,pref,     ! inputs
     &             Phiinl,iBLIc,                     !
     &             pid,pib,pifn,pitn,              !
     &             Gearf,                          !
     &             pifD,pilcD,pihcD,pihtD,piltD,   !
     &             mbfD,mblcD,mbhcD,mbhtD,mbltD,   !
     &             NbfD,NblcD,NbhcD,NbhtD,NbltD,   !
     &             A2,A25,A5,A7,                   !
     &             iTFspec,                        !
     &           Tfuel,ifuel,etab,                 !
     &           epolf,epollc,epolhc,epolht,epollt,  !
     &           pifK,epfK,                          !
     &           icool,                            !
     &           Mtexit,dTstrk,StA,efilm,tfilm,    !
     &           M4a,ruc,                          !
     &           ncrowx,ncrow,                     !
     &           epsrow,Tmrow,                    ! inputs or outputs
     &           TSFC,Fsp,hfuel,ff,               ! outputs
     &           Feng,mcore,                      ! 
     &           pif,pilc,pihc,                   !
     &           mbf,mblc,mbhc,                   !
     &           Nbf,Nblc,Nbhc,                   !
     &           Tt0 ,ht0 ,pt0 ,cpt0 ,Rt0 ,       !
     &           Tt18,ht18,pt18,cpt18,Rt18,
     &           Tt19,ht19,pt19,cpt19,Rt19,
     &           Tt2 ,ht2 ,pt2 ,cpt2 ,Rt2 ,
     &           Tt21,ht21,pt21,cpt21,Rt21,
     &           Tt25,ht25,pt25,cpt25,Rt25,
     &           Tt3 ,ht3 ,pt3 ,cpt3 ,Rt3 ,
     &           Tt4, ht4 ,pt4 ,cpt4 ,Rt4 ,
     &           Tt41,ht41,pt41,cpt41,Rt41,
     &           Tt45,ht45,pt45,cpt45,Rt45,
     &           Tt49,ht49,pt49,cpt49,Rt49,
     &           Tt5 ,ht5 ,pt5 ,cpt5 ,Rt5 ,
     &           Tt7 ,ht7 ,pt7 ,cpt7 ,Rt7 ,
     &               u0 ,
     &           T2, u2 ,p2 ,cp2 ,R2 ,M2 ,
     &           T25,u25,p25,cp25,R25,M25,
     &           T5 ,u5 ,p5 ,cp5 ,R5 ,M5 ,
     &           T6 ,u6 ,p6 ,cp6 ,R6 ,M6 , A6,
     &           T7 ,u7 ,p7 ,cp7 ,R7 ,M7 ,
     &           T8 ,u8 ,p8 ,cp8 ,R8 ,M8 , A8,
     &           epf ,eplc ,ephc ,epht ,eplt , 
     &           etaf,etalc,etahc,etaht,etalt, 
     &           Lconv )

c---- physical speeds and mass flows
      Nf = Nbf *sqrt(Tt2 /Tref)
      N1 = Nblc*sqrt(Tt19/Tref)
      N2 = Nbhc*sqrt(Tt25/Tref)

c---- turbine corrected values
      Nbht = N2/sqrt(Tt41/Tref)
      Nblt = N1/sqrt(Tt45/Tref)
      mbht = mcore*sqrt(Tt41/Tref)/(pt41/pref)*(1.0+ff)
      mblt = mcore*sqrt(Tt45/Tref)/(pt45/pref)*(1.0+ff)

      BPR = mbf/mblc * sqrt(Tt19/Tt2) * pt2/pt19

       write(*,*)
       write(*,3000) 'BPR    =', BPR
       write(*,3000) 'FPR    =', pif
       write(*,3000) 'OPR    =', pilc*pihc
       write(*,3000) 'pilc   =', pilc
       write(*,3000) 'pihc   =', pihc
       write(*,3000) '1/piht =', pt41/pt45
       write(*,3000) '1/pilt =', pt45/pt49
       write(*,3000) 'pid    =', pid
       write(*,3000) 'pib    =', pib
       write(*,3000) 'N1     =', N1
       write(*,3000) 'N2     =', N2
       write(*,3000) 'Nlc_c% =', Nblc/NblcD * 100.0
       write(*,3000) 'Nhc_c% =', Nbhc/NbhcD * 100.0
       write(*,3000) 'Nht_c% =', Nbht/NbhtD * 100.0
       write(*,3000) 'Nlt_c% =', Nblt/NbltD * 100.0
       write(*,3000) 'mlc_c% =', mblc/mblcD * 100.0
       write(*,3000) 'mhc_c% =', mbhc/mbhcD * 100.0
       write(*,3000) 'mht_c% =', mbht/mbhtD * 100.0
       write(*,3000) 'mlt_c% =', mblt/mbltD * 100.0
       write(*,3000) 'mf_c%  =', mbf /mbfD  * 100.0
       write(*,3000) 'epf    =', epf
       write(*,3000) 'eplc   =', eplc
       write(*,3000) 'ephc   =', ephc
       write(*,3000) 'epht   =', epht
       write(*,3000) 'eplt   =', eplt
       write(*,*)
       write(*,3000) 'hfuel  =', hfuel
       write(*,3000) 'epstot =', epstot
       write(*,3000) 'epsrow =', (epsrow(icrow), icrow=1,ncrow)
       write(*,3000) 'Tmrow  =', (Tmrow(icrow) , icrow=1,ncrow)
ccc    write(*,3000) 'M4a    =', M4a
       write(*,*)
       write(*,3000) 'Tfuel =', Tfuel
       write(*,3000) 'ffuel =', ff
       write(*,3000) 'eta_f =', etaf
       write(*,3000) 'eta_lc=', etalc
       write(*,3000) 'eta_hc=', etahc
       write(*,3000) 'eta_ht=', etaht
       write(*,3000) 'eta_lt=', etalt
       write(*,3000) 'TSFC  =', TSFC, TSFC*3600.0
       write(*,3000) 'Fsp   =', Fsp

       write(*,3000) 'Feng  =', Feng
       write(*,3000) 'mcore =', mcore
c       write(*,3000) 'Df    =', dfan  *39.37
c       write(*,3000) 'Dlc   =', dlcomp*39.37
c       write(*,3000) 'Dhc   =', dhcomp*39.37
c       write(*,3000) 'CRPMf =', comegaf  * 30.0/pi
c       write(*,3000) 'CRPMlc=', comegalc * 30.0/pi
c       write(*,3000) 'CRPMhc=', comegahc * 30.0/pi
c       write(*,3000) 'psif  =', psif
c       write(*,3000) 'psilc =', psilc
c       write(*,3000) 'psihc =', psihc
c       write(*,3000) 'pic1  =', pic1
c       write(*,3000) 'NstgLC=', nstagelc
c       write(*,3000) 'NstgHC=', nstagehc


c       write(*,*)
c       write(*,*) '#    mc         Nc         pi        eff'
c       write(*,'(1x,6f11.5)') mfb /mfbD , Nlcb/NlcbD, pif , epf
c       write(*,'(1x,6f11.5)') mlcb/mlcbD, Nlcb/NlcbD, pilc, eplc
c       write(*,'(1x,6f11.5)') mhcb/mhcbD, Nhcb/NhcbD, pihc, ephc
c       write(*,*)

c       write(1,'(1x,6f11.5)') mfb /mfbD , Nlcb/NlcbD, pif , epf
c       write(2,'(1x,6f11.5)') mlcb/mlcbD, Nlcb/NlcbD, pilc, eplc
c       write(3,'(1x,6f11.5)') mhcb/mhcbD, Nhcb/NhcbD, pihc, ephc



       write(*,3100)
       write(*,3150)' 0 ',Tt0 ,pt0 /1000.0,cpt0 ,Rt0 ,cpt0 /(cpt0 -Rt0 )
       write(*,3150)' 18',Tt18,pt18/1000.0,cpt18,Rt18,cpt18/(cpt18-Rt18)
       write(*,3150)' 19',Tt19,pt19/1000.0,cpt19,Rt19,cpt19/(cpt19-Rt19)
       write(*,3150)' 2 ',Tt2 ,pt2 /1000.0,cpt2 ,Rt2 ,cpt2 /(cpt2 -Rt2 )
       write(*,3150)' 21',Tt21,pt21/1000.0,cpt21,Rt21,cpt21/(cpt21-Rt21)
       write(*,3150)' 25',Tt25,pt25/1000.0,cpt25,Rt25,cpt25/(cpt25-Rt25)
       write(*,3150)' 3 ',Tt3 ,pt3 /1000.0,cpt3 ,Rt3 ,cpt3 /(cpt3 -Rt3 )
       write(*,3150)' 4 ',Tt4 ,pt4 /1000.0,cpt4 ,Rt4 ,cpt4 /(cpt4 -Rt4 )
       write(*,3150)' 41',Tt41,pt41/1000.0,cpt41,Rt41,cpt41/(cpt41-Rt41)
       write(*,3150)' 45',Tt45,pt45/1000.0,cpt45,Rt45,cpt45/(cpt45-Rt45)
       write(*,3150)' 49',Tt49,pt49/1000.0,cpt49,Rt49,cpt49/(cpt49-Rt49)
       write(*,3150)' 5 ',Tt5 ,pt5 /1000.0,cpt5 ,Rt5 ,cpt5 /(cpt5 -Rt5 )
       write(*,3150)' 7 ',Tt7 ,pt7 /1000.0,cpt7 ,Rt7 ,cpt7 /(cpt7 -Rt7 )

       write(*,3210)
       write(*,3250) ' 2 -21', (ht21-ht2 )/(Tt21-Tt2 ), etaf
       write(*,3250) ' 19-25', (ht25-ht19)/(Tt25-Tt19), etalc
       write(*,3250) ' 25-3 ', (ht3 -ht25)/(Tt3 -Tt25), etahc
       write(*,3250) ' 41-45', (ht45-ht41)/(Tt45-Tt41), etaht
       write(*,3250) ' 45-49', (ht49-ht45)/(Tt49-Tt45), etalt
c
c      M2 = u2 / sqrt(T2*R2*cp2/(cp2-R2))
c      M25 = u25 / sqrt(T25*R25*cp25/(cp25-R25))
c      M5 = u5 / sqrt(T5*R5*cp5/(cp5-R5))
c      M6 = u6 / sqrt(T6*R6*cp6/(cp6-R6))
c      M7 = u7 / sqrt(T7*R7*cp7/(cp7-R7))
c      M8 = u8 / sqrt(T8*R8*cp8/(cp8-R8))
       ep6 = 2.0/(1.0 + u6/u0)
       ep8 = 2.0/(1.0 + u8/u0)
       F6sp = ((1.0+ff)*u6 - u0)/((1.0+BPR)*a0)
       F8sp = (         u8 - u0)/((1.0+BPR)*a0)
       Fsp = F6sp + F8sp
       Acap = mcore*(1.0+BPR)/(rho0*u0)
       write(*,3300)
       write(*,3350) 0, T0, p0/1000.0, M0, u0, Acap, Fsp  
       write(*,3350) 2, T2, p2/1000.0, M2, u2, A2
       write(*,*)
       write(*,3350) 25,T25,p25/1000.0,M25,u25,A25
       write(*,*)
       write(*,3350) 5, T5, p5/1000.0, M5, u5, A5  
       write(*,3350) 6, T6, p6/1000.0, M6, u6, A6  , F6sp, ep6
       write(*,*)
       write(*,3350) 7, T7, p7/1000.0, M7, u7, A7  
       write(*,3350) 8, T8, p8/1000.0, M8, u8, A8  , F8sp, ep8

       write(*,*)

       write(*,'(8a)')
     & '#      1        2        3       4   ',
     &  '      5        6        7       8   ',
     &  '      9       10       11      12   ',
     &  '     13       14       15      16       17       18'
       write(*,'(8a)')
     & '#    mfc%     Nfc%     pif      epf  ',
     &  '    mlc%     Nlc%     pilc     eplc ',
     &  '    mhc%     Nhc%     pihc     ephc ',
     &  '    F8sp     F6sp     Fsp      TSFC    F(lb)'
c        12345678 12345678 12345678 12345678 12345678 12345678 12345678 12345678 
       write(*,'(1x,16f9.5,f9.1)') 
     &  mbf /mbfD , Nblc/NblcD, pif , epf , 
     &  mblc/mblcD, Nblc/NblcD, pilc, eplc, 
     &  mbhc/mbhcD, Nbhc/NbhcD, pihc, ephc,
     &  F8sp, F6sp, Fsp, TSFC*3600.0, Feng



 800   continue



       stop
       end ! tftest

