      program tptest
c------------------------------------------------------------------
c     Exercises trefftz routine
c------------------------------------------------------------------
      implicit real(a-h,l-z)

      integer ndim
      parameter (ndim=2)
      integer n(ndim), nsurf, ktip
      integer ifrst(ndim), ilast(ndim)

      real po(ndim)
      real b(ndim), bs(ndim), bo(ndim), bop(ndim), zcent(ndim)
      real gamma(ndim), gammas(ndim)
      real clsurfsp(ndim), clsurf(ndim)
      real lift,drag,spanef
      logical Lspec

      parameter (idim=500)
      real yc(idim), ycp(idim),
     &     zc(idim), zcp(idim)
      real gc(idim), vc(idim), wc(idim), vnc(idim)


      Sref = 0.4
      bref = 2.0
      Minf = 0.8

      fLo = -0.5

      b(1) = 2.0
      bs(1) = 0.8
      bo(1) = 0.2
      bop(1) = 0.3
      bop(1) = 0.0
      zcent(1) = -0.1
      po(1) = 1.0
      gammas(1) = 0.9
      gamma(1)  = 0.3
      clsurfsp(1) = 1.0

      b(2) = 0.6
      bs(2) = 0.25
      bo(2) = 0.
      bop(2) = 0.1
c      bop(2) = 0.
      zcent(2) = 0.2
      po(2) = -0.15
      gammas(2) = 0.9
      gamma(2)  = 0.3
      clsurfsp(2) = -0.05




      b(1) = 2.0
      bs(1) = 0.8
      bo(1) = 0.3
      bop(1) = 0.3
      zcent(1) = 0.1
      po(1) = 1.0
      gammas(1) = 0.9
      gamma(1)  = 0.3
      clsurfsp(1) = 1.0

      b(2) = 0.6
      bs(2) = 0.25
      bo(2) = 0.1
      bop(2) = 0.1
      zcent(2) = 0.2
      po(2) = -0.15
      gammas(2) = 0.9
      gamma(2)  = 0.3
      clsurfsp(2) = -0.05


      fduo = 0.06
      fdus = 0.02
      fdut = 0.01

c      fduo = fduo
c      fdus = fdus
c      fdut = fdut

      ktip = 16

      Lspec = .true.
cc      Lspec = .false.

      nsurf = 2
      n(1) = 30
      n(2) = 15

      call trefftz(nsurf, n, Sref, bref, Minf,
     &             b,bs,bo,bop, zcent,
     &             fduo,fdus,fdut,
     &             po,gamma,gammas, fLo,ktip,
     &             Lspec,clsurfsp,
     &             clsurf,CL,CD,spanef,
     &             idim,ifrst,ilast,
     &             yc,zc,gc,vc,wc,vnc, ycp,zcp)

      write(*,*) 'CL =', (clsurf(k), k=1,nsurf)
      write(*,*) 'CD =', CD
      write(*,*) 'e  =', spanef


      call trefftz1(nsurf, n, Sref, bref,
     &             b,bs,bo,bop, zcent,
     &             po,gamma,gammas, fLo,ktip,
     &             Lspec,clsurfsp,
     &             clsurf,CL,CD,spanef,
     &             idim,ifrst,ilast,
     &             yc,zc,gc,vc,wc,vnc, ycp,zcp)

      write(*,*) 'CL =', (clsurf(k), k=1,nsurf)
      write(*,*) 'CD =', CD
      write(*,*) 'e  =', spanef


      do isurf = 1, nsurf
        do i = ifrst(isurf), ilast(isurf)-1
          write(8,'(1x,8g14.6)') 
     &      yc(i), zc(i), ycp(i), zcp(i), gc(i), vnc(i)
        enddo
        write(8,*)
      enddo

      stop
      end

