      
      integer nmisx
      parameter(nmisx = 5)   ! max number of missions

      character*64
     &  configname, 
     &  casename1,
     &  casename2,
     &  airfile,
     &  fnameg,
     &  arg1,
     &  arg2
      character*64
     &  pilabel,
     &  pjlabel,
     &  picolor
      common /arrs_c/
     &  configname,
     &  casename1,
     &  casename2,
     &  airfile(5),
     &  fnameg,
     &  arg1,
     &  arg2,
     &  pilabel,
     &  pjlabel,
     &  picolor

      integer 
     &  pari,
     &  iterwmax,
     &  iterfmax,
     &  istepmax,
     &  istepout,
     &  initwgt,
     &  initeng,
     &  nairf,
     &  nmission,
     &  iovar,
     &  ichoke5,
     &  ichoke7,
     &  narg1,
     &  narg2,
     &  lug

      common /arrs_i/
     &  pari(iitotal),
     &  iterwmax,   ! max weight-sizing iterations for design mission
     &  iterfmax,   ! max fuel-sizing iterations for off-design missions
     &  istepmax,   ! max number of optimization evaluations
     &  istepout,   ! number of opt.evals between xxx.out file outputs
     &  initwgt,    ! 0 = force weight initialization, 1 = don't force
     &  initeng,    ! 0 = force engine-variable initialization, 1 = don't force
     &  nairf,      ! number of airfoil files available
     &  nmission,   ! number of missions
     &  iovar(iototal),    ! indices of selected optimization variables
     &  ichoke5(iptotal,nmisx),  ! 1 = core nozzle choked, 0 = unchoked
     &  ichoke7(iptotal,nmisx),  ! 1 = fan  nozzle choked, 0 = unchoked
     &  narg1,
     &  narg2,
     &  lug

      common /arrs_r/
     & version,        ! TASOPT version number
     & Wftol,          ! fuel weight tolerance for definition of optimum
     & wrlx1,  ! under-relaxation factor for   initial weight iterations
     & wrlx2,  ! under-relaxation factor after initial weight iterations
     & wrlx3,  ! under-relaxation factor near max iteration limit
     & parg(igtotal),                 ! airframe and geometry parameters
     & para(iatotal,iptotal,nmisx),  ! aero   parameters for points, missions
     & pare(ietotal,iptotal,nmisx),  ! engine parameters for points, missions
     & parm(imtotal,nmisx)           ! mission-varying parameters
     
      logical
     &  Litprint,
     &  Loutwrite,
     &  Lsavwrite,
     &  Lfblwrite, 
     &  Ltrpwrite, 
     &  Laswwrite, 
     &  Ltfwrite, 
     &  Lpfwrite, 
     &  Lopt,     
     &  Loprint,  
     &  LlBFcon,  
     &  LWfmaxcon,
     &  Lbmaxcon,
     &  Lgtoccon,
     &  LdBSLcon, 
     &  LdBCBcon
      common /arrs_l/
     &  Litprint,   ! print every weight-sizing iteration?
     &  Loutwrite,  ! write out xxx_iNN_jMM.out file(s)?
     &  Lsavwrite,  ! write out xxx.sav save file?
     &  Lfblwrite,  ! write out xxx.fbl fuselage BL parameter file?
     &  Ltrpwrite,  ! write out xxx.trp Trefftz plane file?
     &  Laswwrite,  ! write out xxx.asw Aswing input file?
     &  Ltfwrite,   ! write out turbofan data?
     &  Lpfwrite,   ! write out mission profiles?
     &  Lopt,       ! optimize?
     &  Loprint,    ! print every optimization step?
     &  LlBFcon,    ! constrain balanced field length?
     &  LWfmaxcon,  ! constrain max fuel volume?
     &  Lbmaxcon,   ! constrain span?
     &  Lgtoccon,   ! constrain top-of-climb climb angle?
     &  LdBSLcon,   ! constrain Sideline noise?
     &  LdBCBcon    ! constrain Cutback noise?
