
c---- indices for axisymmetric flow geometry quantities
      parameter(
     &  jafxbl   = 1,    ! body x coordinates                     
     &  jafzbl   = 2,    ! body z coordinates                     
     &  jafsbl   = 3,    ! body + wake arc length  (BL coordinate)
     &  jafbbl   = 4,    ! transverse width (body perimeter)
     &  jafdybl  = 5,    ! body y-offset of edge-type tail
     &  jaftotal = 5 )

c---- indices for bl quantities
      parameter(
     &  jblui    =  1, ! inviscid edge velocity (in absence of delta*)
     &  jblue    =  2, ! actual edge velocity
     &  jblds    =  3, ! displacement thickness delta*
     &  jblth    =  4, ! momentum thickness theta
     &  jblts    =  5, ! K.E. thickness  theta*
     &  jbldc    =  6, ! density flux thickness  delta**
     &  jblct    =  7, ! max shear stress coefficient
     &  jblcq    =  8, ! equilib.max shear stress coefficient
     &  jblcf    =  9, ! skin friction coefficient
     &  jblcd    = 10, ! dissipation coefficient
     &  jblhk    = 11, ! kinematic shape parameter
     &  jbltotal = 11 )

