
      integer nfreq, nfmid

      parameter (nfreq=24)
      parameter (nfmid=nfreq+1)
     
      real freq(nfreq), fmid(nfmid), dBatten(nfreq), dBAcorr(nfreq)

c---- 10/decade frequencies sampled to integrate over spectrum
      data freq /
     &    50.0 ,
     &    63.0 ,
     &    80.0 ,
     &    100.0 ,
     &    125.0 ,
     &    160.0 ,
     &    200.0 ,
     &    250.0 ,
     &    315.0 ,
     &    400.0 ,
     &    500.0 ,
     &    630.0 ,
     &    800.0 ,
     &    1000.0 ,
     &    1250.0 ,
     &    1600.0 ,
     &    2000.0 ,
     &    2500.0 ,
     &    3150.0 ,
     &    4000.0 ,
     &    5000.0 ,
     &    6300.0 ,
     &    8000.0 ,
     &    10000.0  /

c---- midpoint frequencies used to locate frequency slot index
      data fmid /
     &   44.7 ,
     &   56.2 ,
     &   70.8 ,
     &   89.1 ,
     &   112.2 ,
     &   141.3 ,
     &   177.8 ,
     &   223.9 ,
     &   281.8 ,
     &   354.8 ,
     &   446.7 ,
     &   562.3 ,
     &   707.9 ,
     &   891.3 ,
     &   1122.0 ,
     &   1413.0 ,
     &   1778.0 ,
     &   2239.0 ,
     &   2818.0 ,
     &   3548.0 ,
     &   4467.0 ,
     &   5623.0 ,
     &   7079.0 ,
     &   8913.0 ,
     &   11220.0 /

c---- atmospheric attenuation in dB per 100m
      data dBatten /
     &   -0.004 ,
     &   -0.006 ,
     &   -0.010 ,
     &   -0.015 ,
     &   -0.024 ,
     &   -0.038 ,
     &   -0.059 ,
     &   -0.089 ,
     &   -0.134 ,
     &   -0.201 ,
     &   -0.284 ,
     &   -0.391 ,
     &   -0.519 ,
     &   -0.650 ,
     &   -0.789 ,
     &   -0.957 ,
     &   -1.136 ,
     &   -1.371 ,
     &   -1.716 ,
     &   -2.258 ,
     &   -3.034 ,
     &   -4.309 ,
     &   -6.387 ,
     &   -9.438  /

c---- A-weighting in dB
      data dBAcorr /
     &    -30.2284,
     &    -26.1807,
     &    -22.3613,
     &    -19.1146,
     &    -16.1656,
     &    -13.2267,
     &    -10.8344,
     &     -8.6660,
     &     -6.6379,
     &     -4.7701,
     &     -3.2453,
     &     -1.9068,
     &     -0.7936,
     &      0.0008,
     &      0.5768,
     &      0.9935,
     &      1.2021,
     &      1.2714,
     &      1.2020,
     &      0.9645,
     &      0.5557,
     &     -0.1137,
     &     -1.1443,
     &     -2.4881 /
