
      subroutine fsec(
     &  S,
     &  b,bs,bo,
     &  lambdat,lambdas,gammat,gammas,
     &  toco,tocs,toct,
     &  Mach,sweep,co, 
     &  CL,CLhtail, fLo,fLt,
     &  Reco,aRexp, kSuns,fexcd,
     &  kAdim,lAdim,iAdim,jAdim,
     &  nAcl,nAtau,nAfun,
     &  Acl,Atau,ARe,
     &  nA,A,AM,
     &  clpo,clps,clpt,
     &  CDfwing,CDpwing,CDwing)

      data pi / 3.1415926535897932384626 /

c     n = 4     !  ~0.30% error
c     n = 6     !  ~0.13% error
      n = 8     !  ~0.07% error
c     n = 12    !  ~0.07% error

      cosL = cos(sweep*pi/180.0)

      AR = b**2/S

      etao = bo/b
      etas = bs/b

c---- set center clpo
      elam = etao
     &     + 0.5*(1.0    +lambdas)*(etas-etao)
     &     + 0.5*(lambdas+lambdat)*(1.0 -etas)

      egam = etao
     &     + 0.5*(1.0    +gammas )*(etas-etao)
     &     + 0.5*(gammas +gammat )*(1.0 -etas)

      Ko = 1.0/(AR*elam)
      Kp = egam + fLo*etao + 2.0*fLt*Ko*gammat*lambdat

      clpo = (CL-CLhtail)/cosL**2 * S/(Kp*b*co)

c---- set break and tip clp for passing back
      clps = clpo * gammas/lambdas
      clpt = clpo * gammat/lambdat

      do i = 1, n/2
        frac = (float(i)-0.5)/float(n/2)
        etasec(i) = etao*(1.0-frac) + etas*frac
        detsec(i) = (etas-etao)/float(n/2)
        P = 1.0-frac + gammas *frac
        C = 1.0-frac + lambdas*frac
        toc = toco*(1.0-frac) + tocs*frac
        clpsec(i) = clpo * P/C

        Rec = Reco * C
        Mperp = Mach*cosL
        call airfun(clp,toc,Mperp,
     &              kAdim,lAdim,iAdim,jAdim,
     &              nAcl,nAtau,nAfun,
     &              Acl,Atau,ARe,
     &              nA,A,AM,
     &              cdf1, cdp1, cdwbar, cm)
        Refac = (Rec/ARe)**ARexp
        cdf = cdf1*Refac * fexcd
        cdp = cdp1*Refac * fexcd

        fSuns = exp( -(eta-etao) * b / (kSuns*C * 2.0*co) )

        cd = cdf + cdp*(fSuns + (1.0-fSuns)*cosL**2)*cosL

c        write(*,'(1x,8f12.6)') eta, fSuns, clp, cdf+cdp*cosL**3, cd

        Snorm   = Snorm   + C*deta
        CDwing  = CDwing  + C*deta*cd

        CDfwing = CDfwing + C*deta*cdf
        CDpwing = CDpwing + C*deta*cdp
      enddo

